
def is_v1(filename):
   mp3file = file(filename, 'r')
   try:
      mp3file.seek(-128, 2)
      id3tag = mp3file.read(3)
   except IOError:
      id3tag = ''
   mp3file.close()
   return id3tag == "TAG"

def is_v2(filename):
   mp3file = file(filename, 'r')
   try:
      id3tag = mp3file.read(3)
   except IOError:
      id3tag = ''
   mp3file.close()
   return id3tag == "ID3"

def is_mp3(filename):
   import os
   pipe = os.popen("file -- '%s'" % filename.replace("'", "'\"'\"'"), 'r')
   result = pipe.read()
   code = pipe.close()
   if code <> None: # error
      raise IOError, "error %s reading file pipe for file `%s'" % (code, filename)

   result = result[len(filename) + 2:] # + ": "
   test = "MPEG 1.0 layer 3 audio stream data"
   return result.startswith(test)


def is_wav(filename):
   wavfile = file(filename, 'r')
   try:
      riff_wav = wavfile.read(16)
   except IOError:
      riff_wav = ''
   wavfile.close()
   return riff_wav[:4] == "RIFF" and riff_wav[8:16] == "WAVEfmt "


def is_ogg(filename):
   oggfile = file(filename, 'r')
   try:
      ogg_magic = oggfile.read(4)
   except IOError:
      ogg_magic = ''
   oggfile.close()
   return ogg_magic == "OggS"


def is_flac(filename):
   flacfile = file(filename, 'r')
   try:
      flac_magic = flacfile.read(4)
   except IOError:
      flac_magic = ''
   flacfile.close()
   return flac_magic == "fLaC"


def is_ape(filename):
   apefile = file(filename, 'r')
   try:
      ape_magic = apefile.read(4)
   except IOError:
      ape_magic = ''
   apefile.close()
   return ape_magic == "MAC "
