#! /usr/bin/env python


import sys, os

if len(sys.argv) == 1:
   start_dir = '.'
elif len(sys.argv) == 2:
   start_dir = sys.argv[1]
else:
   sys.exit("Usage: %s [start_dir]" % sys.argv[0])


def find_nolist(arg, dirname, names):
   if dirname == '.': return
   for filename in ("play.list", "list.m3u", "playlist.m3u", "playlist.pls",
         "PlayList.m3u"):
      if filename in names: return
   print dirname


os.path.walk(start_dir, find_nolist, None)
